# ##################################################################################
# Add a IEDN vswitch 
#  updated on 10/17/12 to specify a controller
#  updated this version on 1/23/13 to use-any-available-controller
#  update on 1/25 to use new standard don't specify HMC port and do specify user/pw
#  And updated on 1/25 to allow 2 sets of chpids/devs to be specified - MAT
#  Updated on 1/30/13 to allow bridge port to be specified - MAT
#  Updated on 2/5/13 to allow nouplinks - MAT
# ##################################################################################
import sys, httplib, urllib, json

# argv[0] is the script source
if (len(sys.argv) != 9) and (len(sys.argv) !=11) and (len(sys.argv) !=13) and (len(sys.argv) !=8):
   print "\n"
   print "usage:"
   print "addvswitch.py <ip> <hmc-user> <password> <nodename> <hiper-name> <real-devno> <chpid> <vswitchname> <bkup-devno> <bkup-chpid> <bridge-port-role (pri or sec)> <bridge-port-device> "
   print "or:                                                                                "
   print "addvswitch.py <ip> <hmc-user> <password> <nodename> <hiper-name> nouplinks"
   print "\n"
   print "example:       addvswitch.py 9.12.16.241 ensadmin password P93 VML1 284 38 VSWITAPI"
   print "\n"
   print "Or:                                                                                "
   print "\n"                                                                                   
   print "example:       addvswitch.py 9.12.16.241 ensadmin password P93 VML1 284 38 VSWITAPI 298 39"
   print "\n"
   print "Or:                                                                                "
   print "\n"                                                                                   
   print "example:       addvswitch.py 9.12.16.241 ensadmin password P93 VML1 284 38 VSWITAPI 298 39 pri e400"
   print "\n"
   print "Or:                                                                                "
   print "\n"                                                                                   
   print "example:       addvswitch.py 9.12.16.241 ensadmin password P93 VML1 284 38 VSWITAPI pri e400"
   print "\n"                                                                                   
   print "example:       addvswitch.py 9.12.16.241 ensadmin password P93 VML1 nouplinks VSWITAPI"
   print "\n" 
   exit()
# use the command line arguments for the params (note: no further error checking being done)

if (len(sys.argv) == 8):
   if (str(sys.argv[6]) == 'nouplinks'):
      host = str(sys.argv[1])
      port = 6794
      ensuser = str(sys.argv[2])
      enspw = str(sys.argv[3]) 
      nodename = str(sys.argv[4])
      hname = str(sys.argv[5])
      rdevnum = 'none'
      chpidnum = 'none'
      vswitname = str(sys.argv[7])
      rdevnum2 = 'none'
      chpidnum2 = 'none'
      bridgerole = 'none'
      bridgedev = 'none'
      uplinks = 'none'

      print >>sys.stderr, "Adding a VSWITCH in Hipervisor: " + hname + " on Node: " + nodename + " with no uplinks " + " with name " + vswitname + " using any available controller "

      print >>sys.stderr, "args:",host,ensuser,nodename,hname,vswitname
   else:
      print >>sys.stderr, "Without uplink devices specified, the nouplinks parm must be specified"
      exit()

if (len(sys.argv) == 9):

   host = str(sys.argv[1])
   port = 6794
   ensuser = str(sys.argv[2])
   enspw = str(sys.argv[3]) 
   nodename = str(sys.argv[4])
   hname = str(sys.argv[5])
   rdevnum = str(sys.argv[6])
   chpidnum = str(sys.argv[7])
   vswitname = str(sys.argv[8])
   rdevnum2 = 'none'
   chpidnum2 = 'none'
   bridgerole = 'none'
   bridgedev = 'none'
   uplinks = 'one'

   print >>sys.stderr, "Adding a VSWITCH in Hipervisor: " + hname + " on Node: " + nodename + " on real dev " + rdevnum + " using chpid " + chpidnum + " with name " + vswitname + " using any available controller "

   print >>sys.stderr, "args:",host,ensuser,nodename,hname,rdevnum,chpidnum,vswitname

if (len(sys.argv) == 11):
   if (str(sys.argv[9]) == 'pri') or (str(sys.argv[9]) == 'sec'):

      host = str(sys.argv[1])
      port = 6794
      ensuser = str(sys.argv[2])
      enspw = str(sys.argv[3]) 
      nodename = str(sys.argv[4])
      hname = str(sys.argv[5])
      rdevnum = str(sys.argv[6])
      chpidnum = str(sys.argv[7])
      vswitname = str(sys.argv[8])
      rdevnum2 = 'none'
      chpidnum2 = 'none'
      bridgerole = str(sys.argv[9])
      bridgedev = str(sys.argv[10])
      uplinks = 'one'

      print >>sys.stderr, "Adding a VSWITCH in Hipervisor: " + hname + " on Node: " + nodename + " on real dev " + rdevnum + " using chpid " + chpidnum + " with name " + vswitname + " bridge-role " + bridgerole + " bridge-device " + bridgedev + " using any available controller "

      print >>sys.stderr, "args:",host,ensuser,nodename,hname,rdevnum,chpidnum,vswitname,bridgerole,bridgedev

   else:        

      host = str(sys.argv[1])
      port = 6794
      ensuser = str(sys.argv[2])
      enspw = str(sys.argv[3]) 
      nodename = str(sys.argv[4])
      hname = str(sys.argv[5])
      rdevnum = str(sys.argv[6])
      chpidnum = str(sys.argv[7])
      vswitname = str(sys.argv[8])
      rdevnum2 = str(sys.argv[9])
      chpidnum2 = str(sys.argv[10])
      bridgerole = 'none'
      bridgedev = 'none'
      uplinks = 'two'

      print >>sys.stderr, "Adding a VSWITCH in Hipervisor: " + hname + " on Node: " + nodename + " on real devs " + rdevnum + " and " + rdevnum2 + " using chpids " + chpidnum + " and " + chpidnum2 + " with name " + vswitname + " using any available controller "

      print >>sys.stderr, "args:",host,ensuser,nodename,hname,rdevnum,chpidnum,vswitname,rdevnum2,chpidnum2

if (len(sys.argv) == 13):
   if (str(sys.argv[11]) == 'pri') or (str(sys.argv[11]) == 'sec'):

      host = str(sys.argv[1])
      port = 6794
      ensuser = str(sys.argv[2])
      enspw = str(sys.argv[3]) 
      nodename = str(sys.argv[4])
      hname = str(sys.argv[5])
      rdevnum = str(sys.argv[6])
      chpidnum = str(sys.argv[7])
      vswitname = str(sys.argv[8])
      rdevnum2 = str(sys.argv[9])
      chpidnum2 = str(sys.argv[10])
      bridgerole = str(sys.argv[11])
      bridgedev = str(sys.argv[12])
      uplinks = 'two'

      print >>sys.stderr, "Adding a VSWITCH in Hipervisor: " + hname + " on Node: " + nodename + " using real devices " + rdevnum + " and " +  rdevnum2 + " using chpids " + chpidnum + " and " + chpidnum2 + " with name " + vswitname + " with bridge-role " + bridgerole + " and  bridge-device " + bridgedev + " using any available controller "

      print >>sys.stderr, "args:",host,ensuser,nodename,hname,rdevnum,chpidnum,vswitname,rdevnum2,chpidnum2,bridgerole,bridgedev

   else:        

      print "A bridge port role of pri or sec must be specified"
      print "\n" 
      exit()


# #############################################################################
# Convert the device numbers & chpid to upper - but iqdx or osx has to be lower
# #############################################################################

chpidup = chpidnum.upper()
rdevup = rdevnum.upper()
chpidnum = chpidup
rdevnum = rdevup

if rdevnum2 != 'none':
   rdev2up = rdevnum2.upper()
   rdevnum2 = rdev2up

if chpidnum2 != 'none':
   chpid2up = chpidnum2.upper()
   chpidnum2 = chpid2up

if bridgedev != 'none':
   bridgeup = bridgedev.upper()
   bridgedev = bridgeup

# ##########################################################################
# Logon
# ##########################################################################

headers = {"Content-type":"application/json","Accept":"*/*"}

body = json.dumps({"userid":ensuser,"password":enspw})

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", "/api/session",body,headers)
response = conn.getresponse()

# this session header is important.
apiSessionHeader = response.getheader( "X-API-Session" );
# print >>sys.stderr, "session header:", apiSessionHeader

# ##########################################################################
# Query for Ensemble ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", "/api/ensembles", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   ensembleid = y.get("object-uri")
   print >>sys.stderr, "Here is the ensemble ID for ", hname
   print >>sys.stderr, "  ", ensembleid

# ##########################################################################
# Query for NODE ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", ensembleid + "/nodes", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
      mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   if y.get("name") == nodename:
      nodeid = y.get("element-uri")
      print >>sys.stderr, "Here is the Node ID (element-uri) for ", nodename
      print >>sys.stderr, "  ", nodeid

# ##########################################################################
# Query for member from NODE properties
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodeid, "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:

#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

#      # we already got our object; pack it in a list
#      # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:

    nodemember = y.get("member")
    print >>sys.stderr, "Here is the MemberID (member) for ", nodename
    print >>sys.stderr, "  ", nodemember


# ##########################################################################
# Query for virtualization-hosts ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodemember + "/virtualization-hosts", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == hname:
      hiperid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtualization-host ID (object-uri) for ", hname
      print >>sys.stderr, "  ", hiperid

# ###############################################################################
# Query for virtual server ID of the LPAR Virtual Server - using nodename (CPC)
# ###############################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodemember + "/virtual-servers", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == hname:

###debug      print json.dumps(mylist,sort_keys=True, indent=4)
      prsmvsid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtual-server ID (object-uri) for the Virtual Server object for ", hname
      print >>sys.stderr, "  ", prsmvsid
      htype = y.get("type")
      print >>sys.stderr, "Here is the Type (type) for the Virtual Server object for ", hname
      print >>sys.stderr, "  ", htype

# ##########################################################################
# Query for the virtual server properties of the PRSM virtual server 
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", prsmvsid, "", headers)
response = conn.getresponse()

###debug print >>sys.stderr, "post status", response.status, "post reason", response.reason
mystuff = json.loads(response.read())
###debug print >>sys.stderr, "body:", mystuff
###debug print >>sys.stderr

## try to get parameter value from target
if len(mystuff) == 1:
   print >>sys.stderr, "length of mystuff is 1", mystuff
   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
   ###debug print >>sys.stderr, "length of mystuff is not 1", mystuff
   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   myadapters = y.get("network-adapters")

###debug   print >>sys.stderr, "                              "
###debug   print >>sys.stderr, "Here are the Network Adapters:"
###debug   print >>sys.stderr, "                              "
###debug   print >>sys.stderr, myadapters

for z in myadapters:

   if z.get("chpid") == chpidnum:

      adapturi = z.get("element-uri")
      print >>sys.stderr, "Here is the element-uri for the network adapter for chpid: ", chpidnum
      print >>sys.stderr, " ", adapturi

if rdevnum2 != 'none':
   for z in myadapters:

      if z.get("chpid") == chpidnum2:

         adapturi2 = z.get("element-uri")
         print >>sys.stderr, "Here is the element-uri for the network adapter for chpid: ", chpidnum2
         print >>sys.stderr, " ", adapturi


###########################################################################
#### SET POST BODY
###########################################################################

if (rdevnum2 == 'none') and (bridgerole == 'none') and (uplinks != 'none'):
   request_body = json.dumps({"is-connect-uplinks":True,"real-uplinks":[{"switch-uri":adapturi,"device-number":rdevnum}],"name":vswitname,"is-use-any-available-controller":True})

if (rdevnum2 != 'none') and (bridgerole == 'none'):

   rdevnum = rdevnum + '.P00'
   rdevnum2 = rdevnum2 + '.P00'
   request_body = json.dumps({"is-connect-uplinks":True,"real-uplinks":[{"switch-uri":adapturi,"device-number":rdevnum},{"switch-uri":adapturi2,"device-number":rdevnum2}],"name":vswitname,"is-use-any-available-controller":True})

if (rdevnum2 != 'none') and (bridgerole != 'none'):

   rdevnum = rdevnum + '.P00'
   rdevnum2 = rdevnum2 + '.P00'
   if bridgerole == 'pri':
      bridgetype = 'primary'
   if bridgerole == 'sec':
      bridgetype = 'secondary'
   request_body = json.dumps({"is-connect-uplinks":True,"real-uplinks":[{"switch-uri":adapturi,"device-number":rdevnum},{"switch-uri":adapturi2,"device-number":rdevnum2}],"name":vswitname,"is-use-any-available-controller":True,"bridge-value-type":bridgetype,"bridge-device-number":bridgedev})

if (rdevnum2 == 'none') and (bridgerole != 'none'):

   if bridgerole == 'pri':
      bridgetype = 'primary'
   if bridgerole == 'sec':
      bridgetype = 'secondary'
   request_body = json.dumps({"is-connect-uplinks":True,"real-uplinks":[{"switch-uri":adapturi,"device-number":rdevnum}],"name":vswitname,"is-use-any-available-controller":True,"bridge-value-type":bridgetype,"bridge-device-number":bridgedev})

if (uplinks == 'none'):
   request_body = json.dumps({"is-connect-uplinks":False,"name":vswitname,"is-use-any-available-controller":True})
   
print >>sys.stderr, "request_body: ", request_body

# ##########################################################################
# POST TO ADD VSWITCH
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

print >>sys.stderr, "\nAttempting POST to add VSWITCH:"

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", hiperid + "/virtual-switches/operations/create-iedn", request_body, headers)

response = conn.getresponse()
print >>sys.stderr, "post status", response.status, "post reason", response.reason
mystuff = json.loads(response.read())
print >>sys.stderr, "body:", mystuff
print >>sys.stderr



# ##########################################################################
# Now we'll logoff
# ##########################################################################
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}
print >>sys.stderr, "\nAttempting LOGOFF:"

conn = httplib.HTTPSConnection(host,port)

conn.request("DELETE", "/api/session/this-session","",headers)
response = conn.getresponse()
print >>sys.stderr, "delete status", response.status, "delete reason", response.reason
print >>sys.stderr, "body:", response.read()

