# ###########################################################################################
#  Set GPMP option and assign the RMC virual device address
# ############################################################################################
import sys, httplib, urllib, json

# argv[0] is the script source
if (len(sys.argv) != 8) and (len(sys.argv) !=9):
   print "usage:"
   print "gpmp.py <ip> <hmc-user> <password> <nodename> <hiper-name> <virtual-server-name> <true or false> <RMC-device-num-if-true>"
   print "example: gpmp.py 9.12.16.236 ensadmin password P95 VML1 GSSP28 true 1200"
   print "  or                                                      "
   print "example: gpmp.py 9.12.16.236 ensadmin password P95 VML1 GSSP28 false"
   exit()
#

if len(sys.argv) == 8: 
   host = str(sys.argv[1])
   port = 6794
   ensuser = str(sys.argv[2])
   enspw = str(sys.argv[3]) 
   nodename = str(sys.argv[4])
   hname = str(sys.argv[5])
   vname = str(sys.argv[6])
   torf = str(sys.argv[7])
   if torf == 'true' :
      print "usage:"
      print "gpmp.py <ip> <hmc-user> <password> <nodename> <hiper-name> <virtual-server-name> <true or false> <RMC-device-num-if-true> "
      print "example: gpmp.py 9.12.16.236 ensadmin password P95 VML1 GSSP28 true 1200 "
      print "  or                                                      "
      print "example: gpmp.py 9.12.16.236 ensadmin password P95 VML1 GSSP28 false"
      exit()
   else:
      print >>sys.stderr, "Setting GPMP option on VHOST " + vname + " in Hipervisor: " + hname + " on Node: " + nodename + " to " + torf
      print >>sys.stderr, "                                                          "
      print >>sys.stderr, "Success returns: post status 204 post reason No Content"
      print >>sys.stderr, "                                                          "
      print >>sys.stderr, "args:",host,ensuser,nodename,hname,vname,torf
      falsebody = json.dumps({"gpmp-support-enabled":False})

if len(sys.argv) == 9:
   host = str(sys.argv[1])
   port = 6794
   ensuser = str(sys.argv[2])
   enspw = str(sys.argv[3]) 
   nodename = str(sys.argv[4])
   hname = str(sys.argv[5])
   vname = str(sys.argv[6])
   torf = str(sys.argv[7])
   rmcdev = str(sys.argv[8])
   if torf == 'false' :
      print "usage:"
      print "gpmp.py <ip> <hmc-user> <password> <nodename> <hiper-name> <virtual-server-name> <true or false> <RMC-device-num-if-true> "
      print "example: gpmp.py 9.12.16.236 ensadmin password P95 VML1 GSSP28 true 1200 "
      print "  or                                                      "
      print "example: gpmp.py 9.12.16.236 ensadmin password P95 VML1 GSSP28 false"
      exit()
   else:
      print >>sys.stderr, "Setting GPMP option on VHOST " + vname + " in Hipervisor: " + hname + " on Node: " + nodename + " to " + torf + " with RMC device " + rmcdev
      print >>sys.stderr, "                                                          "
      print >>sys.stderr, "Success returns: post status 204 post reason No Content"
      print >>sys.stderr, "                                                          "
      print >>sys.stderr, "args:",host,ensuser,nodename,hname,vname,torf,rmcdev
      truebody = json.dumps({"gpmp-support-enabled":True,"rmc-virtual-device-address":rmcdev})

if (torf != 'true') and (torf != 'false'):
   print "usage:"
   print "gpmp.py <ip> <hmc-user> <password> <nodename> <hiper-name> <virtual-server-name> <true or false> <RMC-device-num-if-true> "
   print "example: gpmp.py 9.12.16.236 ensadmin password R01 VML1 GSSP28 true 1200 "
   print "  or                                                      "
   print "example: gpmp.py 9.12.16.236 ensadmin R01 VML1 GSSP28 false"
   exit()


# ##########################################################################
# Logon
# ##########################################################################

headers = {"Content-type":"application/json","Accept":"*/*"}
# Login credentials live in body 
##body = "{\"userid\":\"ensadmin\",\"password\":\"password\"}"
body = json.dumps({"userid":ensuser,"password":enspw})

conn = httplib.HTTPSConnection(host,port)

conn.request("POST", "/api/session",body,headers)
response = conn.getresponse()

# this session header is important.
apiSessionHeader = response.getheader( "X-API-Session" );
# print >>sys.stderr, "session header:", apiSessionHeader

# ##########################################################################
# Query for Ensemble ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", "/api/ensembles", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   ensembleid = y.get("object-uri")
   print >>sys.stderr, "Here is the ensemble ID for ", hname
   print >>sys.stderr, "  ", ensembleid

# ##########################################################################
# Query for NODE ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", ensembleid + "/nodes", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:
#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:
      mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:
   if y.get("name") == nodename:
      nodeid = y.get("element-uri")
      print >>sys.stderr, "Here is the Node ID (element-uri) for ", nodename
      print >>sys.stderr, "  ", nodeid

# ##########################################################################
# Query for member from NODE properties
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodeid, "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

# try to get parameter value from target
if len(mystuff) == 1:

#      # then we have a list nested in here somewhere
#      # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

#      # we already got our object; pack it in a list
#      # so we can handle both cases in same way
   mylist = [ mystuff ]

   # now go through the list and print the selected item
for y in mylist:

    nodemember = y.get("member")
    print >>sys.stderr, "Here is the MemberID (member) for ", nodename
    print >>sys.stderr, "  ", nodemember


# ##########################################################################
# Query for virtualization-hosts ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", nodemember + "/virtualization-hosts", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == hname:
      hiperid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtualization-host ID (object-uri) for ", hname
      print >>sys.stderr, "  ", hiperid

   
# ##########################################################################
# Query for virtual server ID
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

conn = httplib.HTTPSConnection(host,port)

conn.request("GET", hiperid + "/virtual-servers", "", headers)
response = conn.getresponse()

mystuff = json.loads(response.read())

## try to get parameter value from target
if len(mystuff) == 1:

   # then we have a list nested in here somewhere
   # and have to dig deeper to get the list of objects
   for x in mystuff: 
      mylist = mystuff[x]
else:

   # we already got our object; pack it in a list
   # so we can handle both cases in same way
   mylist = [ mystuff ]
   # now go through the list and print the selected item
for y in mylist:

   if y.get("name") == vname:

      vsid = y.get("object-uri")
      print >>sys.stderr, "Here is the virtual-server ID (object-uri) for ", vname
      print >>sys.stderr, "  ", vsid

# ##########################################################################
# POST TO SET GPMP OPTION
# ##########################################################################
# Notice that there is a session header provided here so it takes advantage of the previous
# logon code. 
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}

if torf == 'true':

   print >>sys.stderr, "body:", truebody

   print >>sys.stderr, "\nAttempting POST to set GPMP option to: " + torf

   conn = httplib.HTTPSConnection(host,port)
   
   conn.request("POST", vsid, truebody, headers)
if torf == 'false':
   print >>sys.stderr, "body:", falsebody

   print >>sys.stderr, "\nAttempting POST to set GPMP option to: " + torf

   conn = httplib.HTTPSConnection(host,port)
   
   conn.request("POST", vsid, falsebody, headers)

response = conn.getresponse()
print >>sys.stderr, "post status", response.status, "post reason", response.reason
##mystuff = json.loads(response.read())
##print >>sys.stderr, "body:", mystuff
##print >>sys.stderr



# ##########################################################################
# Now we'll logoff
# ##########################################################################
headers = {"Content-type":"application/json","Accept":"*/*","X-API-Session":apiSessionHeader}
print >>sys.stderr, "\nAttempting LOGOFF:"

conn = httplib.HTTPSConnection(host,port)

conn.request("DELETE", "/api/session/this-session","",headers)
response = conn.getresponse()
print >>sys.stderr, "delete status", response.status, "delete reason", response.reason


